SoGLMultiTextureImageElement(3)

NAME
SoGLMultiTextureImageElement - The SoGLMultiTextureImageElement class is used to control the current GL texture for texture units.

SYNOPSIS

#include <Inventor/elements/SoGLMultiTextureImageElement.h>

Inherits SoMultiTextureImageElement.

  Classes
class GLUnitData

  Public Member Functions
virtual void init (SoState *state)
virtual void push (SoState *state)
virtual void pop (SoState *state, const SoElement *prevTopElement)

  Static Public Member Functions
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void * createInstance (void)
static void initClass (void)
static void set (SoState *const state, SoNode *const node, const int unit, SoGLImage *image, const Model model, const SbColor &blendColor)
static void restore (SoState *state, const int unit)
static SoGLImage * get (SoState *state, const int unit, Model &model, SbColor &blendcolor)
static SbBool hasTransparency (SoState *state)
static void set (SoState *const state, SoNode *const node, SoGLImage *image, const Model model, const SbColor &blendColor)
static SoGLImage * get (SoState *state, Model &model, SbColor &blendcolor)
static int32_t getMaxGLTextureSize (void)

  Protected Member Functions
SoGLMultiTextureImageElement (void)
virtual ~SoGLMultiTextureImageElement ()
virtual SbBool hasTransparency (const int unit=0) const

  Additional Inherited Members

Detailed Description

The SoGLMultiTextureImageElement class is used to control the current GL texture for texture units. FIXME: write doc.

Constructor & Destructor Documentation

  SoGLMultiTextureImageElement::SoGLMultiTextureImageElement (void) [protected]
Constructor.

  SoGLMultiTextureImageElement::~SoGLMultiTextureImageElement (void) [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoGLMultiTextureImageElement::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  int SoGLMultiTextureImageElement::getClassStackIndex (void) [static]
This static method returns the state stack index for the class.

  void * SoGLMultiTextureImageElement::createInstance (void) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Creates a new instance of the class type corresponding to the SoType object.

  void SoGLMultiTextureImageElement::initClass (void) [static]
Initialize relevant common data for all instances, like the type system.

  void SoGLMultiTextureImageElement::init (SoState * state) [virtual]
Initializes the element to its default value.

Reimplemented from SoMultiTextureImageElement.

  void SoGLMultiTextureImageElement::push (SoState * state) [virtual]
This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoMultiTextureImageElement.

  void SoGLMultiTextureImageElement::pop (SoState * state, const SoElement * prevTopElement) [virtual]
This method is called when the state is popped, and the depth of the element is bigger than the current state depth. pop() is called on the new top of stack, and a pointer to the previous top of stack is passed in prevTopElement.

Override this method if you need to copy some state information from the previous top of stack.

Reimplemented from SoElement.

  void SoGLMultiTextureImageElement::set (SoState *const state, SoNode *const node, const int unit, SoGLImage * image, const Model model, const SbColor & blendColor) [static]
Sets the current texture. Id didapply is TRUE, it is assumed that the texture image already is the current GL texture. Do not use this feature unless you know what you're doing.

  SbBool SoGLMultiTextureImageElement::hasTransparency (SoState * state) [static]
Returns TRUE if any of the images have at least one transparent pixel.

Since
    Coin 3.1

  SbBool SoGLMultiTextureImageElement::hasTransparency (const int unit = 0) const [protected], [virtual]
Called by containsTransparency(). Returns TRUE if image data has transparency. Default method does a very poor job of detecting this, since it returns TRUE when the number of components are 2 or

4.  Override whenever it is important to know this (SoGLTextureImageElement overrides it to avoid transparency handling where possible).

Reimplemented from SoMultiTextureImageElement.

  int32_t SoGLMultiTextureImageElement::getMaxGLTextureSize (void) [static]
The size returned by this function will just be a very coarse estimate as it only uses the more or less obsoleted technique of calling glGetIntegerv(GL_MAX_TEXTURE_SIZE).

For a better estimate, use SoGLTextureImageElement::isTextureSizeLegal().

Note that this function needs an OpenGL context to be made current for it to work. Without that, you will most likely get a faulty return value or even a crash.

Author

Generated automatically by Doxygen for Coin from the source code.